


var={'faH','faH','Capital flow','Capital flow'
        'RER','RER','Exchange rate','Exchange rate'
         'phH', 'phF','Bubble^{US}','Bubble^{CH}'
         'YH', 'YF','Y^{US}','Y^{CH}'                  
         'CH','CF','C^{US}','C^{CH}'
         'IH','IF','Inv^{US}','Inv^{CH}'
         'sH','sF','Sentiment^{US}','Sentiment^{CH}'
         'qkH','qkF','TobinQ^{US}','TobinQ^{CH}'
         'piH','piF','\pi^{US}','\pi^{CH}'
         'BHF','BFH','Captal Inflow^{US}','Capital Inflow^{CH}'};
varnames={'$fa^H$','$fa^H$'
                   '$RER$','$RER$'
                   '$p^{hH}$','$p^{hF}$'
                   '$Y^{H}$','$Y^{F}$'
                   '$C^{H}$','$C^{F}$'
                   '$K^{H}$','$K^{F}$'
                   '$s^{H}$','$s^{F}$'
                   '$q^{kH}$','$q^{kF}$'
                   '$\pi^{H}$','$\pi^{F}$'
                   '$B_{US}^{CH}$','B_{CH}^{US}$'};
shocks={'eAH','eAF'
              'esH','esF'
              'eRH','eF'
              'eHx','eFx'};
shocksname={'$\epsilon_A^H$','$\epsilon_A^F$'
                       '$\epsilon_s^H$','$\epsilon_s^F$'
                       '$\epsilon_R^H$','$\epsilon_R^F$'
                       '$\epsilon_x^H$','$\epsilon_x^F$'};


%% plot bayesian irf
% eg:YH_eAH YF_eAF
for i=1:length(var)
    for j=1:length(shocks)
        for m=1:2;
            eval([var{i,m} '_' shocks{j,m} '=[];'])
        end
    end
end




%assign bayes irf with hpd 90% 
for i=1:length(var)
    for j=1:length(shocks)
        for m=1:2;
            eval([var{i,m} '_' shocks{j,m} '(1,:)=oo_.PosteriorIRF.dsge.HPDinf.' var{i,m} '_' shocks{j,m} ';'])
            eval([var{i,m} '_' shocks{j,m} '(2,:)=oo_.PosteriorIRF.dsge.Median.' var{i,m} '_' shocks{j,m} ';'])
            eval([var{i,m} '_' shocks{j,m} '(3,:)=oo_.PosteriorIRF.dsge.HPDsup.' var{i,m} '_' shocks{j,m} ';'])
            eval([var{i,m} '_' shocks{j,m} '(4,:)=oo_.PosteriorIRF.dsge.Var.' var{i,m} '_' shocks{j,m} ';'])
        end
    end
end


for m=1:2
    figure(m)
    for i=1:length(var)
        for j=1:length(shocks)
            x=[];
            for q=1:3
                eval(['x(q,:)=' var{i,m} '_' shocks{j,m} '(q,:);'])
            end
            ii=4*(i-1)+j;
            subplot(length(var),length(shocks),ii)
            plot(x(1,:),'--k','LineWidth',1);
            hold on
            plot(x(2,:),'-k','LineWidth',1);
            plot(x(3,:),'--k','LineWidth',1);
        end
    end
    for jj=1:length(shocks)
        subplot(length(var),length(shocks),jj)
        title(shocksname{jj,m},'Interpreter','latex')
    end
    for jjj=1:length(var)
        subplot(length(var),length(shocks),(jjj-1)*4+1)
        ylabel(varnames{jjj,m},'Interpreter','latex')
    end

end

%variance
 figure(3)
for i=1:length(var)
    for j=1:length(shocks)
        eval(['x=' var{i,m} '_' shocks{j,m} '(4,:);'])
        ii=4*(i-1)+j;
        subplot(length(var),length(shocks),ii)
        plot(x,'-k','LineWidth',1);
    end
end
for jj=1:length(shocks)
    subplot(length(var),length(shocks),jj)
    title(shocksname{jj,m},'Interpreter','latex')
end
for jjj=1:length(var)
    subplot(length(var),length(shocks),(jjj-1)*4+1)
    ylabel(varnames{jjj,m},'Interpreter','latex')
end
    
%% smoothed shocks
figure(4);
for m=1:2
    for j=1:length(shocks)
        subplot(4,2,(j-1)*2+m)
        eval(['irf=oo_.SmoothedShocks.' shocks{j,m} ';'])
        plot(dates('1981Q1'):dates('2023Q3'),irf,'k-');
        xlim([1981.25 2023.75]);
        title(shocksname{j,m},'FontName','Times New Roman' ,'FontSize',11,'Interpreter','latex')
        box on
    end
end


%% variance decomposition
VDH=[];   %nxm, n:shocks, m:variables
VDF=[];    
for i=1:length(var)
    for j=1:length(shocks)
         eval(['VDH(i,j)=oo_.PosteriorTheoreticalMoments.dsge.VarianceDecomposition.Mean.' var{i,1} '.' shocks{j,1} ';'])
         eval(['VDH(i,4+j)=oo_.PosteriorTheoreticalMoments.dsge.VarianceDecomposition.Mean.' var{i,1} '.' shocks{j,2} ';'])
         eval(['VDF(i,j)=oo_.PosteriorTheoreticalMoments.dsge.VarianceDecomposition.Mean.' var{i,2} '.' shocks{j,1} ';'])
         eval(['VDF(i,4+j)=oo_.PosteriorTheoreticalMoments.dsge.VarianceDecomposition.Mean.' var{i,2} '.' shocks{j,2} ';'])
    end
end
yH=var(1:length(var),3);
yF=var(1:length(var),4);
xvalues={'\epsilon_A^{US}' ,'\epsilon_s^{US}','\epsilon_R^{US}','\epsilon_x^{US}','\epsilon_A^{CH}','\epsilon_s^{CH}','\epsilon_R^{CH}','\epsilon_x^{CH}',};
figure(5)
h1=heatmap(xvalues,yH,VDH*100)
h1.xlabel('shocks')
title('Variance Decompostion for US Variables')

figure(6)
gca.Interpreter='latex'
h2=heatmap(xvalues,yF,VDF*100)
h2.xlabel('shocks')
title('Variance Decompostion for CH Variables')


%% hist decomposition
shocks={'eAH','eRH','esH','eF'
              'eAF','eF','esF','eRH'};
shocknames={'$\epsilon_A^{US}$','$\epsilon_R^{US}$','$\epsilon_H^{US}$','$\epsilon_R^{CH}$','$Residual$'
                       '$\epsilon_A^{CH}$','$\epsilon_R^{CH}$','$\epsilon_H^{CH}$','$\epsilon_R^{US}$','$Residual$'};
color_matrix=[0.9 0.9 0.9
                       0.7 0.7 0.7
                       0.5 0.5 0.5
                       0.3 0.3 0.3
                       0.2 0.2 0.2
                       1 1 1];
hist.H=[];
hist.F=[];
nx=[];
ne=[];
for m=1:2
    for i=1:length(var)
        ne(m,i)=find(strcmp(M_.endo_names,var{i,m}));
        for j=1:length(shocks)
            nx(m,j)=find(strcmp(M_.exo_names,shocks{m,j}));
        end
    end
end

for i=1:length(var)
    for j=1:size(shocks,2)
        eval(['hist.H(i,j,:)=squeeze(oo_.shock_decomposition(ne(1,i),nx(1,j),:));'])
        eval(['hist.H(i,j+1,:)=squeeze(oo_.shock_decomposition(ne(1,i),10,:)-sum(oo_.shock_decomposition(ne(1,i),1:9,:)));'])
        eval(['hist.H(i,j+2,:)=squeeze(oo_.shock_decomposition(ne(1,i),10,:));'])

        %F
        eval(['hist.F(i,j,:)=squeeze(oo_.shock_decomposition(ne(2,i),nx(2,j),:));'])
        eval(['hist.F(i,j+1,:)=squeeze(oo_.shock_decomposition(ne(2,i),10,:)-sum(oo_.shock_decomposition(ne(2,i),1:9,:)));'])
        eval(['hist.F(i,j+2,:)=squeeze(oo_.shock_decomposition(ne(2,i),10,:));'])
    end
end
color_matrix=[0.9 0.9 0.9
                       0.7 0.7 0.7
                       0.5 0.5 0.5
                       0.3 0.3 0.3
                       1 1 1]; 
t={'H', 'F'};
for i=1:length(var)
    for m=1:length(t)
    figure(6+(i-1)*2+m)
    eval(['A=squeeze(hist.' t{m} '(i,:,:));'])
    h=bar(dates('1981Q1'):dates('2023Q3'),A(1:5,:)',"stacked")
    hold on
        for j=1:length(shocks)+1
            set(h(j),'facecolor',color_matrix(j,:))
        end
    eval(['irf=A(6,:);'])
    b=plot(dates('1981Q1'):dates('2023Q3'),irf,'color','k','Linewidth', 1.5);
    xlim([1989.75 2022.25]);
    title(varnames{i,m},'FontName','Times New Roman' ,'FontSize',11,'Interpreter','latex')
   
    hold off;
    legend(shocknames{m,:},'Location','southoutside','orientation','horizontal','FontName','Times New Roman' ,'FontSize',10.5,'Interpreter','Latex')

    end
end


       
   