


warning off;

var 
%% developing country
CH pH LamH wH YH AH LH mcH RkH BHF BHH KH phH sH qkH IH 
epsilonH1 epsilonH2 epsilonH3 ppiH piH prH x1H x2H FH RH tbH faH

%% developed country
CF pF LamF wF YF AF LF mcF RkF BFH BFF KF phF sF qkF IF 
epsilonF1 epsilonF2 epsilonF3 ppiF piF prF x1F x2F FF RF tbF faF

%% exchange rate
RER

%varobs


tbHx Hx tbFx Fx

tbH_YH;



varexo eAH eAF eRH esH esF eF eHx eFx; 

parameters

%% common parameters 21
vH vF eta beta sigma alpha deltah tauH tauF muH muF phi omegaH omegaF
delta sigmap Kai zeta n LHss

%% shock parameters 11
rhoaH rhoaF rhosH rhosF rhorH rhorF rhopiH rhopiF rhoyH rhoyF rhoe

%%shock std 6
%sAH sAF ssH ssF sRH sRF

%% steady state parameters 11
piHs piFs AHs AFs sHs sFs RERs

%dependent parameters
%YHs YFs RHs RFs PsiH PsiF

%third country demand
Hxs Fxs rhox
;


@# include "parameters.inc"
model;
@# include "dependent_parameters.inc"
%%%%%%%%%%%%%% developing country %%%%%%%%%%%%%%%
%%%%%%%%%%%%%% developing country %%%%%%%%%%%%%%%
%(1)
1=vH*exp((1-eta)*pH)+(1-vH)*exp(RER*(1-eta))*exp(pF*(1-eta));

%(2) Euler equation
exp(LamH)=beta*exp(-sigma*CH)/exp(-sigma*CH(-1));

%(3) Labor supply
exp(PsiH*LH)=exp(-sigma*CH)*exp(wH);

%(4) Production function
exp(FH)*exp(YH)=exp(AH)*exp(alpha*KH(-1))*exp((1-alpha)*LH);

%(5) wage
exp(wH)=(1-alpha)*exp(mcH)*exp(AH)*exp(alpha*KH(-1))*exp(-alpha*LH);

%(6)RkH
exp(RkH)=alpha*exp(mcH)*exp(AH)*exp((alpha-1)*KH(-1))*exp((1-alpha)*LH);

%(7)AH
AH=rhoaH*AH(-1)+eAH;

%(8)phH
exp(phH)=beta*exp(LamH(+1))/exp(LamH)*exp(sH(+1))*exp(phH(+1))*(1-deltah)*(1+tauH/(1-tauH)*((1-tauH)/exp(epsilonH1(+1)))^(1/tauH));

%(9)sH
sH=(1-rhosH)*log(sHs)+rhosH*sH(-1)+esH;

%(10) tobin's Q
%exp(EH1)=exp(epsilonH1)*(exp(epsilonH1)/(1-tau))^(1/tau);
%exp(EH2)=exp(epsilonH2)*(exp(epsilonH2)/(1-tau))^(1/tau);
%exp(EH3)=exp(epsilonH3)*(exp(epsilonH3)/(1-tau))^(1/tau);

%exp(qkH)=beta*exp(Lam(+1))/exp(Lam)*(1+tau/(1-tau)*(exp(epsilonH1)/(1-tau))^(-1/tau))+beta*exp(Lam(+1))/exp(Lam)*exp(qkH)*(1-delta)+beta*exp(Lam(+1))/exp(Lam)*exp(qkH(+1))*exp(EH2(+1))*muH*tau/(1-tau)+beta*exp(Lam(+1))/exp(Lam)*exp(qkH(+1))*exp(EH3(+1))*tau^2/((1-tau^2)*phi);

exp(qkH)=beta*exp(LamH(+1))/exp(LamH)*(         exp(RkH(+1))* (  1 + (exp( epsilonH1(+1))/(1-tauH))^(-1/tauH)  *tauH/(1-tauH) )   +  exp(qkH(+1))*(1-delta)    +       exp(RH(+1))   *   (exp(epsilonH2(+1))/(1-tauH))^(-1/tauH)     *    tauH/(1-tauH)     * muH     +      exp(RH(+1))   *  exp(omegaH)    *     (exp(epsilonH3(+1))/(1-tauH))^(-1/tauH)     *     tauH^2/(phi*(1-tauH^2))     )    ;

%(11)
exp(piH(+1))/exp(RH)=beta*exp(LamH(+1))/exp(LamH)*(1+tauH*(exp(epsilonH1)/(1-tauH))^(-1/tauH)/(1-tauH));

%(12)epsilonH1
exp(epsilonH1)=1/exp(qkH);

%(13)epsilonH2
exp(epsilonH2)=exp(RH)/exp(qkH);

%(14)epsilonH3
exp(epsilonH3)=exp(RH)*exp(omegaH)/exp(qkH);

%(15)investment
exp(IH)=(exp(epsilonH1)/(1-tauH))^(-1/tauH)*(   exp(RkH)*exp(KH(-1))    +  exp(phH(-1))   -    exp(BHF(-1))*exp(RH(-1))*exp(omegaH)/exp(piH)   -   exp(BHH(-1))*exp(RH(-1))/exp(piH)    )       +   (exp(epsilonH2)/(1-tauH))^(-1/tauH)*muH*exp(KH(-1))          +        (exp(epsilonH3)/(1-tauH))^(-1/tauH)*exp(KH(-1))*tauH/(phi*(1+2*tauH));

%(16)capital
exp(KH)=(1-delta)*exp(KH(-1))   +   (  exp(epsilonH1)/(1-tauH)  )^(1-1/tauH)*  (   exp(RkH)*exp(KH(-1))  +  exp(phH(-1))  -  exp(BHF(-1))*exp(RH(-1))*exp(omegaH)/exp(piH)     -    exp(BHH(-1))*exp(RH(-1))/exp(piH)  )  +      (   exp(epsilonH2)  /  (1-tauH)  )^(1-1/tauH)*    muH*exp(KH(-1))     +   (exp(epsilonH3)/(1-tauH))^(1-1/tauH)    *    exp(KH(-1))   *tauH  /  (phi*(1+tauH));

%(17)BHF
exp(BHF)=exp(KH(-1))/phi*(exp(epsilonH3)/(1-tauH))^(-1/tauH)*tauH/(1+tauH);

%(18)BHH
exp(BHH)=muH*(exp(KH(-1)))*(exp(epsilonH2)/(1-tauH))^(-1/tauH);

%(19)
exp(FH)=zeta*exp(FH(-1))*exp(sigmap*ppiH)/exp(sigmap*Kai*ppiH(-1))+(1-zeta)*exp(-sigmap*prH);

%(20)
1=zeta*exp(ppiH*(sigmap-1))/exp(ppiH(-1)*Kai*(sigmap-1))+(1-zeta)*exp(prH*(1-sigmap));

%(21)
exp(prH)=sigmap/(sigmap-1)*exp(x1H)/exp(x2H);

%(22)
exp(x1H)=exp(YH)*exp(mcH)+zeta*exp(LamH(+1))*exp(ppiH(+1)*sigmap)/exp(ppiH*Kai*sigmap)*exp(x1H(+1));

%(23)
exp(x2H)=exp(YH)*exp(pH)+zeta*exp(LamH(+1))*exp(ppiH(+1)*(sigmap-1))/exp(ppiH*Kai*(sigmap-1))*exp(x2H(+1));

%(24)
exp(ppiH)=exp(piH)*exp(pH)/exp(pH(-1));

%(25)
RH=rhorH*RH(-1)+(1-rhorH)*(log(RHs)+rhopiH*(piH-log(piHs))+rhoyH*(YH-log(YHs))+rhoe*(RER-log(RERs)))-eRH;

%(26)resource constraints
exp(CH)+exp(IH)+tbH+tbHx=exp(YH)*exp(pH);

%(27)trade balance
tbH=exp(BHF(-1))*exp(RH(-1))/exp(piH)-(1-n)/n*exp(BFH(-1))*exp(RF(-1))*exp(RER)/exp(piF)-(1-n)/n*0.5/phi*exp(2*RER)*exp(KF(-1))*(exp(epsilonF3)/(1-tauF))^(-1/tauF)-exp(BHF)+0.5/phi*exp(KH(-1))*(exp(epsilonH3)/(1-tauH))^(-1/tauH)+(1-n)/n*exp(BFH)*exp(RER);

%(28) final goods demand
exp(YH)=vH*exp(-eta*pH)*(exp(CH)+exp(IH))+(1-vF)*(1-n)/n*exp(-eta*pH)/exp(-eta*RER)*(exp(CF)+exp(IF));

%(29) financial acount
%faH=exp(BHF)-exp(BHF(-1))-(1-n)/n*exp(RER)*(exp(BFH)-exp(BFH(-1)));
faH=exp(BHF)-exp(RER)*exp(BFH);

%%%%%%%%%%%%%%%%%%developed countries%%%%%%%%%

%(30)
1=vF*exp((1-eta)*pF)+(1-vF)*exp((1-eta)*pH)/exp((1-eta)*RER);

%(31)
exp(LamF)=beta*exp(-sigma*CF)/exp(-sigma*CF(-1));

%(32) labor supply
exp(PsiF*LF)=exp(-sigma*CF)*exp(wF);

%(33)
exp(FF)*exp(YF)=exp(AF)*exp(alpha*KF(-1))*exp((1-alpha)*LF);

%(34)
exp(wF)=(1-alpha)*exp(mcF)*exp(AF)*exp(alpha*KF(-1))*exp(-alpha*LF);

%(35)
exp(RkF)=alpha*exp(mcF)*exp(AF)*exp((alpha-1)*KF(-1))*exp((1-alpha)*LF);

%(36)
AF=rhoaF*AF(-1)+eAF;

%(37)
exp(phF)=beta*exp(LamF(+1))/exp(LamF)*exp(sF(+1))*exp(phF(+1))*(1-deltah)*(1+tauF/(1-tauF)*(1-tauF)^(1/tauF)/exp(1/tauF*epsilonF1(+1)));

%(38)
sF=(1-rhosF)*log(sFs)+rhosF*sF(-1)+esF;

%(39)
%#exp(EH1)=exp(epsilonH1)*(exp(epsilonH1)/(1-tau))^(1/tau);
%#exp(EH2)=exp(epsilonH2)*(exp(epsilonH2)/(1-tau))^(1/tau);
%#exp(EH3)=exp(epsilonH3)*(exp(epsilonH3)/(1-tau))^(1/tau);

%exp(qkF)=beta*exp(LamF(+1))/exp(LamF)*(1+tau/(1-tau)*(exp(epsilonH1)/(1-tau))^(-1/tau))+beta*exp(Lam(+1))/exp(Lam)*exp(qkH)*(1-delta)+beta*exp(Lam(+1))/exp(Lam)*exp(qkH(+1))*exp(EH2(+1))*muH*tau/(1-tau)+beta*exp(Lam(+1))/exp(Lam)*exp(qkH(+1))*exp(EH3(+1))*tau^2/((1-tau^2)*phi);

exp(qkF)=beta*exp(LamF(+1))/exp(LamF)*    (   exp(RkF(+1))*(1+tauF/(1-tauF)*(exp(epsilonF1(+1))/(1-tauF))^(-1/tauF))      +    exp(qkF(+1))*(1-delta)   +    exp(RF(+1)) * (exp(epsilonF2(+1))/(1-tauF))^(-1/tauF) *tauF*muF/(1-tauF)    +     exp(RF(+1))*exp(omegaF)*(exp(epsilonF3(+1))/(1-tauF))^(-1/tauF)*tauF^2/(phi*(1-tauF^2))     );

%(40)
exp(piF(+1))/exp(RF)=beta*exp(LamF(+1))/exp(LamF)*(1+tauF/(1-tauF)*(exp(epsilonF1(+1))/(1-tauF))^(-1/tauF));


%(41)
exp(epsilonF1)=1/exp(qkF);

%(42)
exp(epsilonF2)=exp(RF)/exp(qkF);

%(43)
exp(epsilonF3)=exp(RF)*exp(omegaF)/exp(qkF);

%(44)Investiment
exp(IF)=(exp(epsilonF1)/(1-tauF))^(-1/tauF)*( exp(RkF)*exp(KF(-1))  +  exp(phF(-1))   -    exp(BFH(-1))*exp(RF(-1))*exp(omegaF)/exp(piF)    -     exp(BFF(-1))*exp(RF(-1))/exp(piF))  +    muF*exp(KF(-1))*(exp(epsilonF2)/(1-tauF))^(-1/tauF)   +   exp(KF(-1))*tauF/(phi*(1+2*tauF))*(exp(epsilonF3)/(1-tauF))^(-1/tauF);

%(45)Capital
exp(KF)=(1-delta)*exp(KF(-1))+exp(epsilonF1)/(1-tauF)*(exp(epsilonF1)/(1-tauF))^(-1/tauF)*(  exp(RkF)*exp(KF(-1))   +exp(phF(-1))   -exp(BFH(-1))*exp(RF(-1))*exp(omegaF)/exp(piF)    -   exp(BFF(-1))*exp(RF(-1))/exp(piF))      +      muF*exp(KF(-1))*exp(epsilonF2)/(1-tauF)*(exp(epsilonF2)/(1-tauF))^(-1/tauF)    +    exp(KF(-1))*tauF/(phi*(1-tauF^2))*exp(epsilonF3)*(exp(epsilonF3)/(1-tauF))^(-1/tauF);

%(46)BFH
exp(BFH)=exp(KF(-1))*tauF/(phi*(1+tauF))*(exp(epsilonF3)/(1-tauF))^(-1/tauF);

%(47)BFF
exp(BFF)=muF*exp(KF(-1))*(exp(epsilonF2)/(1-tauF))^(-1/tauF);

%(48)FF
exp(FF)=zeta*exp(FF(-1))*exp(ppiF*sigmap)/exp(ppiF(-1)*Kai*sigmap)+(1-zeta)*exp(-sigmap*prF);

%(49)
1=zeta*exp(ppiF*(sigmap-1))/exp(ppiF(-1)*Kai*(sigmap-1))+(1-zeta)*exp((1-sigmap)*prF);

%(50)
exp(prF)=sigmap/(sigmap-1)*exp(x1F)/exp(x2F);

%(51)x1F
exp(x1F)=exp(YF)*exp(mcF)+zeta*exp(LamF(+1))*exp(ppiF(+1)*sigmap)/exp(ppiF*Kai*sigmap)*exp(x1F(+1));

%(52)x2F
exp(x2F)=exp(YF)*exp(pF)+zeta*exp(LamF(+1))*exp(ppiF(+1)*(sigmap-1))/exp(ppiF*Kai*(sigmap-1))*exp(x2F(+1));

%(53)ppiF
exp(ppiF)=exp(piF)*exp(pF)/exp(pF(-1));

%(54)RF
RF=rhorF*RF(-1)+(1-rhorF)*(log(RFs)+rhopiF*(piF-log(piFs))+rhoyF*(YF-log(YFs)) )+eF;

%(55)tbF
tbF=-n/(1-n)*tbH/exp(RER);

%(56)final goods demand
exp(YF)=n/(1-n)*(1-vH)*exp(-eta*pF)*exp(-eta*RER)*(exp(CH)+exp(IH))+vF*exp(-eta*pF)*(exp(CF)+exp(IF))+exp(Fx)*YFs;

%(57)fa
faF=-n/(1-n)*faH/exp(RER);

%(58)tbHx trade balance between H and  the third country
tbHx=-exp(Hx)*YHs;

%(59)tbFx trade balance between F and the third country
tbFx=exp(pF)*exp(Fx)*YFs;

%(60)Hx
%exp(Hx)=(1-rhox)*Hxs+rhox*exp(Hx(-1))+eHx;
Hx=(1-rhox)*log(Hxs)+rhox*Hx(-1)+eHx;
%(61)
%exp(Fx)=(1-rhox)*Fxs+rhox*exp(Fx(-1))+eFx;
Fx=(1-rhox)*log(Fxs)+rhox*Fx(-1)+eFx;


%(62)
tbH_YH=tbH/exp(YH);
end;

shocks;
var eAH=0.0025;
var eAF=0.0025;
var eRH=0.0025;
var eF=0.0025;
var esH=0.0025;
var esF=0.0025;
var eHx=0.0025;
var eFx=0.0025;



end;

steady;



@# include "estimation.inc"

