
%clc; close all; clear all;

%% this code computes and saves parameters for 2-country bubble assets model

%parameters 
vH=0.9;               % openess for home(China; developing) country
vF=0.9;                % openess for foreign country
eta=1.1;               % elasticity for import goods to home goods
%beta=0.995;         % discount rate
beta=0.95;
sigma=1.02;        % elasticity for intertempory
alpha=0.6;           % capital
deltah=0.01;      % bubble crash rate
muH=0.2;             % LTV rate for home country
muF=0.5;             % LTV rate for foreign country
phi=1;                  % adjustment cost
omegaH=0.8;       % tax rate for capital inflow in home country
omegaF=0.5;        % tax rate for capital inflow in foreign country
delta=0.2;         % rate
sigmap=11;           % elasticity
Kai=0.3;                % price indexation
zeta=0.75;            % price stickness
%rhoA rhosH rhosF rhoR rhopi rhoY rhoe
rhoaH=0.9;             % technology AR(1)
rhoaF=0.9;

rhosH=0.9;             % sensitivity AR(1)
rhosF=0.9;

rhorH=0.8;
rhorF=0.8;

%rhopi=2.1;
rhopiH=1.5;
rhopiH=1.5;

rhoyH=0.125;
rhoyF=0.125;

rhoe=0.5;
n=0.5;
%piHs=1.02;
AFs=1;
AHs=1;
RERs=1;
LHs=1/3;
piFs=1.01;
piHs=1.01;
%RHs=1.01;
tauH=0.3;
tauF=0.3;
ph_YHs=0.2;
IH_YHs=0.2;

ph_YFs=0.9;
IF_YFs=0.3;
%% steadystate (numerical computation)
options = optimoptions('fsolve','MaxFunEvals',3000000,'MaxIter',300000,'TolFun',1e-6);

pH0=1;                       % Initial guessa

%x = fsolve(@(pp) letmefind_steady(pp,beta,piHs,deltah,omegaH,phi,RERs,eta,vF,vH,zeta,sigmap,Kai,LHs,alpha,AHs,muH,muF,delta,omegaF,piFs,n,ph_YH,ph_YF,IH_YH,IF_YF),[0.8,0.8,0.8,0.8],options);
%haha_steady(pp,beta, delta, piHs,omegaH,phi,RERs,eta, vH, vF, zeta, sigmap,Kai)
%hahaha_steady(pp,beta, deltah,delta, piHs,piFs,omegaH,omegaF,phi,RERs,eta, vH, vF, zeta, sigmap,Kai,muH,muF,alpha)
%x = fsolve(@(pp) hahaha_steady(pp,beta, deltah, delta,piHs,piFs,omegaH,omegaF,phi,RERs,eta, vH, vF, zeta, sigmap,Kai,muH,muF,alpha),[0.9,0.5,0.9,0.5],options);
%xH = fsolve(@(pp) haha_steady(pp,beta, deltah, delta,piHs,omegaH,phi,RERs,eta, vH, vF, zeta, sigmap,Kai,muH,alpha,ph_YHs,IH_YHs),[0.9],options);
%xF= fsolve(@(pp) hahaF_steady(pp,beta, deltah, delta,piFs,omegaF,phi,RERs,eta, vH, vF, zeta, sigmap,Kai,muF,alpha,ph_YFs,IF_YFs),[1,0.5],options);
xF= fsolve(@(pp) hahaF_steady(pp,beta, deltah, delta,piFs,omegaF,phi,RERs,eta, vH, vF, zeta, sigmap,Kai,muF,alpha,ph_YFs,tauF),[1],options);
xH = fsolve(@(pp) haha_steady(pp,beta, deltah, delta,piHs,omegaH,phi,RERs,eta, vH, vF, zeta, sigmap,Kai,muH,alpha,ph_YHs,tauH),[0.9],options);

%sHs=xH(1);
%tauH=xH(2);
%sFs=xF(1);
%tauF=xF(2);
sFs=xF;
sHs=xH;
